<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Tutorial: Graphical editor for maps and curves</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Tutorial: Graphical editor for maps and curves</h1>

    <section>

<header>
    

    <h2>Graphical editor for maps and curves</h2>
</header>

<article>
    <!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Signal Sources and Oscilloscope</title>
  </head>
  <style>
    .jsscript
    {
      font-weight: bold;  
      color:blue;  
    }

#objOfConst{
  width: 800px;
  height: auto;
  position: relative;
  top: 10px;
  left: 0px;
}

.objOfCharger{
  width: 800px;
  height: auto;
  position: relative;
  top: 10px;
  left: 0px;
}
.obj2dmap{
  width: 800px;
  height: auto;
  position: relative;
  top: 10px;
  left: 0px;
}

#confExplain{
  width: 1000px;
  height: auto;
  position: relative;
  top: 20px;
  left: 0px; 
}

footer{
  position: relative;
  top:20px; 
}

  </style>
  
  <body>       
    <h3>File Structure and Artifacts</h3>     
    <h4>File Structure</h4>     
    <p>
    <dl>
    <dt><ul><li class='jsscript'>main: root folder</li></ul></dt>
    <dd>
    <ul>
      <li>buildscripts : linux shell scripts to prepare build steps</li>
      <li>confGitlabRunner : runner configuration template for gitlab CI runner</li>
      <li>confPython : configuration info for python</li>
      <li>CSS : style sheets</li>
      <li>custom-template : customization configuration for the node documenation build</li>
      <li>docs : created documentations</li>
      <li class='jsscript'>HTML : web pages in HTML </li>
      <li>images : pictures for all kind of illustrations</li>
      <li>node_modules : created by npm install according to the package.json configuration</li>
      <li>node_scripts : customized javascript modules used by node.js</li>
      <li>projects : sub file structure that covers all projects underneath the main node.js application </li>
      <li class='jsscript'>Script : javascripts which are loaded into the client side HTML pages </li>
      <li>test : API self tests in Mocha using the Chai assertion library </li>
    </ul>
    </dd>
    </dl>

    The three highlighted folders are covering the functionality which shall be discussed by tutorial.  
    </p>
    <h4>Artifacts</h4>     
    <dl>
      <dt><ul><li>main: root folder</li></ul></dt>
      <dd>
      <ul>
        <li>index.js : main node.js application</li>
      </ul>
      </dd>
    </dl>
    <dl>
      <dt><ul><li>HTML: javascripts for client</li></ul></dt>
      <dd>
      <ul>
        <li>signalsNOsci.html : select input signals, distribute them to the simulation module and visualize all data</li>
      </ul>
      </dd>
    </dl>
    <dl>
      <dt><ul><li>Script: javascripts for client</li></ul></dt>
      <dd>
      <ul>
        <li>audio-element.js : audi file processing</li>
      </ul>
      </dd>
    </dl>


    </p> 
    <h3>Converting Amplitude-Time Behavior into Sound Files </h3>      
    <h4>csv_to_wav.y<h4>   
    <h2 id="algebEngModData">Data structure array for algebraic engine model</h2>
<p></p>
<hr>
<h3>Module : Script/createDataViz.js </h3>
<table>
<caption>configData'div'</caption>
<thead>
<tr>
  <th>class name 'div'</th>
  <th>header name 'h3'</th>
  <th>elements 'button'</th>
</tr>
</thead>
<tbody>
<tr>
  <td>engine</td>
  <td>Engine Data</td>
  <td>'EngineConstants','EngineAmbientConditions','EngineEta','EngineFriction','EngineVolumEff'</td>
</tr>
<tr>
  <td>compressor</td>
  <td>CompressorData</td>
  <td>'EngineCompr','EngineFullLoadData'</td>
</tr>
<tr>
  <td>turbine</td>
  <td>VNT Data</td>
  <td>'EngineTurbine'</td>
</tr>
<tr>
  <td>exhaust</td>
  <td>Exhaust Data</td>
  <td>'EngineExhaustParam'</td>
</tr>
<tr>
  <td>emissions</td>
  <td>Emmission Data</td>
  <td>'EngineRawParticulates','EngineRawNox'</td>
</tr>
<tr>
  <td>roadloads</td>
  <td>Road loads</td>
  <td>'EngineRoadLoads'</td>
</tr>
</tbody>
</table>
<p>Table 1</p>
<p>The algebraic engine model is divided into 6 topics which are visulized by 6 buttons. Each topic is structured by the following elements: 
  <li>h3 headline : top element of each topic</li>
  <li>button : the user my activate each topic by pressing a pushbutton </li>
  <li>callback function on pushed button : a topic specific table editor creator function </li>
  There are 12 keys for 12 datasets in the posgres data set. The 12 keys are connected to the 6 topics according to table 1. 
</p>
<hr>
<h3>Module handleModelData.js</h3>
<p></p>

<table>
<caption>configArray</caption>
<thead>
<tr>
<th>name</th>
<th>data</th>
</tr>
</thead>
<tbody>
<tr>
<td>EngineConstants</td>
<td>['Tamb[K]','Pamb[bar]','R [J/kg/K]','Lambda_ref','E_LHV [J/kg]','C_p[J/kg/K]','Gamma(C_p/C_v)','Fuel H/C Ratio']</td>
</tr>
<tr>
<td>EngineFullLoadData</td>
<td>['Engine type, 2-stoke:1, 4-Stroke:2','Engine Cylinders','Engine Displacement [m^3]']</td>
</tr>
<tr>
<td>EngineAmbientConditions</td>
<td>['DfuelSp[kg/m^3]/S_p[m/s]']</td>
</tr>
<tr>
  <td>EngineEta</td>
  <td>['FExh/Fman']</td>
</tr>
<tr>
  <td>EngineFriction</td>
  <td>['Dman [kg/m^3] / S_p [m/s][kPa]']</td>
</tr>
<tr>
  <td>EngineVolumEff</td>
  <td>['Dman [kg/m^3] / S_p [m/s]']</td>
</tr>
<tr>
  <td>EngineCompr</td>
  <td>['Ncor[rpm]', 'WcompCor[kg/s]','PrComp[-]','EtaComp[-]','P_ref [Pa]','T_ref [K]','TCompDoCrit [K]']</td>
</tr>
<tr>
  <td>EngineFullLoadData</td>
  <td>['Engine type, 2-stoke:1, 4-Stroke:2','Engine Cylinders','Engine Displacement [m^3]']</td>
</tr>
<tr>
  <td>EngineTurbine</td>
  <td>['ThVNT','Ncor','PrTurb','WTurbCor','EtaTurb']</td>
</tr>
<tr>
  <td>EngineExhaustParam</td>
  <td>['Assumed Average Turbine Efficiency','Average Exhaust Specific Heat,Cp[J/kg/K]','Average Exhaust Specific Heat Ratio[-]</td>
</tr>
<tr>
  <td>EngineExhaustParam</td>
  <td>['Assumed Average Turbine Efficiency','Average Exhaust Specific Heat,Cp[J/kg/K]','Average Exhaust Specific Heat Ratio[-],'Average Gas Constant, R[J/kg/K','Average Exhaust Gas Visc.[Pa*s]','Piece','Pipe Length[mm]','Outer Pipe Diameter[mm]',
    'pieces','Element length[mm]','Element Diameter[mm]','Element Cell Density[1/m^2]','AT element cell wall thickness[mm]','Fraction of cells blocked','Relative Roughness'] </td>
</tr>
</tr>
<tr>
  <td>EngineRawParticulates</td>
  <td>['DFuelSp [kg/m^3] / S_p [m/s]']</td>
</tr>
<tr>
  <td>EngineRawNox</td>
  <td>['DFuelSp [kg/m^3] / S_p [m/s]']</td>
</tr>
<tr>
  <td>EngineRoadLoads</td>
  <td>['Time[s]','Engine Speed[rpm]','BMEP[bar]']</td>
</tr>
</tbody>
</table>
<p>Table 2</p>
    
   <p>For the explanation of the prototype function <a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a> </p>
   
   <h4>2. Generate 3d surface data and graphic</h4>

   <p>Script/surface3d.js: </p>

   <p>surface3d.js defines and calls a function in one step.
    <p> (function()={<br>
      &nbsp; &nbsp;&nbsp; &nbsp;var Surface=function(node)
      <br>
      &nbsp; &nbsp;&nbsp; &nbsp;{ <br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;    this.member_0 = ...<br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;    this.member_1 = ...<br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;    ...<br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;    this.member_n = ...<br>
      <br>
      &nbsp; &nbsp;&nbsp; &nbsp;}; <br>
      &nbsp; &nbsp;&nbsp; &nbsp;d3.selection.prototype.surface3D=function(width,height){<br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;if(!this.node().__surface__) this.node().__surface__=new Surface(this);<br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;var surface=this.node().__surface__;<br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;this.turntable=surface.setTurtable;<br>
        &nbsp; &nbsp;&nbsp; &nbsp;}<br>
      })();
    </p> 
    
      The last opening and closing parenthesis is the function call of an outer function. The outer function contains the variable "Surface" 
      which is equal to a function of a DOM node. This variable assigns members to the calling object and there are values assigned to them 
      which are again typically functions/methods. 

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceConstructor_00.png" />    
        <p>The picture shows a d3 selector after surface3d.js has created the function prototype for Surface3D (see d3.selection.prototype.surface3D). 
          The "this" pointer of the object points on the d3.selection "group". The corresponding node is the group "g".
        </p> 
      </div>

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceConstructor_01.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceConstructor_02.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_00.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_01.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>      

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_02.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>
      
      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_03.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_04.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>
      
      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="RotationMatrix.png" />    
        <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
          order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
        outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
      </div>
     
      
      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_05.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div> 

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_06.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>
      
      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_07.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_08.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div> 

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_09.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div> 
      
      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_10.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div> 

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_11.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>       

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="graphicalMap_EditField.png" />    
        <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
          order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
        outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
      </div>
    
      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="3dMap.png" />    
        <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
          order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
        outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
      </div>


      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_12.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>
      
      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_13.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>

      <div id="objOfConst">     
        <h4>Set of constants</h4>
        <img src="SurfaceInit_14.png" />    
        <p>The above image shows the "__data__" and the "__surface__" element of the selected group. The data element is filled with content by
          the d3.selection standard method "data(...)". The member "__surface__" is created according to the function surface3D. 
        </p> 
      </div>
      
      </p> 


   Note : The code of surface3d.js is included into the html. The code will be called as a function in the next release. 

   <table>
    <caption>d3.selection.prototype.surface3D=function(width,height)</caption>
    <thead><tr><th>Member</th><th>Method</th><th>description</th></tr></thead>
    <tr><td>__surface__</td><td>new Surface(this)</td><td>if there is no surface object yet, create a surface object and store it to the __surface__ member</td></tr>
    <tr><td>turntable</td><td>surface.setTurtable</td><td>copy the turntable method from the __surface__ member to the node</td></tr>
    <tr><td>surfaceColor</td><td>map</td><td>copy surface color method to this node member</td></tr>
    <tr><td>surfaceHeight</td><td>map</td><td>copy surface heigth method to this node member</td></tr>
    <tr><td>surfaceXAxis</td><td>map</td><td>copy surface x axis to this node member</td></tr>
    <tr><td>surfaceYAxis</td><td>multiple curves</td><td>copy surface y axis to this node member</td></tr>
    <tr><td>zoom</td><td>multiple curves</td><td>zoom factor method of surface object</td></tr>
    <tr><td>transition</td><td>surface.transition.bind(surface)</td><td>tansition method of a d3 selection is used to fade in the new surface object</td></tr>
  </table>


   
   <h4> 2.1 create default data </h4>
   <p> var surfaces=[ <br>
       { 
        &nbsp; &nbsp;&nbsp; &nbsp;    name: 'Dataset 1',<br>
        &nbsp; &nbsp;&nbsp; &nbsp;    data: dataFromFormular(function(x,y)<br>
        &nbsp; &nbsp;&nbsp; &nbsp;    {<br>
        &nbsp; &nbsp;&nbsp; &nbsp; &nbsp; &nbsp;&nbsp; &nbsp; return Math.sin(Math.sqrt(x*x+y*y)/5*Math.PI)*50;<br>
        &nbsp; &nbsp;&nbsp; &nbsp; });<br>
     },</p>
   
   <h4>2.2 Attach data to a d3 selection and create surface3D object</h4>
    <p>var md=group.data([surfaces[0].data])</p>
    <p>.surface3D(width,height)<br>
         &nbsp; &nbsp;&nbsp; &nbsp; .surfaceHeight(function(d){
         return d;
       })<br>
        &nbsp; &nbsp;&nbsp; &nbsp;.surfaceColor(function(d)<br>
        &nbsp; &nbsp;&nbsp; &nbsp;{<br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;var c=d3.hsl((d+100), 0.6, 0.5).rgb();<br>
        &nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;&nbsp; &nbsp;return "rgb("+parseInt(c.r)+","+parseInt(c.g)+","+parseInt(c.b)+")";<br>
        &nbsp; &nbsp;&nbsp; &nbsp;})<br>
        &nbsp; &nbsp;&nbsp; &nbsp;.surfaceXAxis(function(d){ return d})<br>
        &nbsp; &nbsp;&nbsp; &nbsp;.surfaceYAxis(function(d){return d});</p>
   
  <h4>2.3 Update data : function dataFromDatabase</h4>
  
  <h4>2.4 Create new surface</h4>
 
<p>
  Event handler for the pushbutton : creates topic specific table editors selected
  by the user on selecting a button <br>
  The handler executes the following steps:
  <li>delete previous editor tables : (d3.select('.table').selectAll('tr').remove();)</li> 
  <li>extract topic related data from postgres dataset (filter:key connected to the pushbutton) </li>
  <li>convert extracted data into a JS object var Obj = JSON.parse(postgresData[cmpString]</li>  
  <li>create a topic specific table editor</li>
 <br>
  The key values of the postgres data are listed in the name element of a JS object. The data field of the object contains those keys which 
  are expected in the columns of the postgres data structure of the corresponding topic (see table 2).  
</p>
<p>
  The table editors are created by the following functions : 
  <li>function insertHeadline(headline) : select the empty table capsule by ID and set table caption to key value (eq. to button name)</li>
  <li>function insertRow (collector,data) : insert a new row (tr elmenent)</li>
  <li>insertCell()</li>
  The following screeshots show examples for the 3 implemented data structures and their configuration. 
</p>
<h4>Configuration</h4>
<li>The name member consists of the 12 keys for in the postgres dataset</li>
<li>The data member consists of all expected columns names for one topic in the postgres dataset</li>

 

  <div id="objOfConst">     
    <h4>Set of constants</h4>
    <img src="EfficiencyNPressureRatio.png" />    
    <p>The data tag in configArray contains the expected column names. In a loop over all expected column names and the column names the 
      order of the data columns is found and pushed into a collector array.The collector vector with the names is the 1st row of an 
    outer collector vector. In case of data constants the 2nd row contains the data vector of the postgres structure.</p> 
  </div>

 
  

</p>
<div id="confExplain">

</div>
</body>
</html>
</article>

</section>

</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>